

pipeline {
    agent any
    tools {
        nodejs "node"
    }
    stages {
        stage('increment version') {
            steps {
                script {
                    dir("app") {
                        echo 'incrementing app version...'
                        sh "npm version minor"

                        # read the updated version from package.json
                        def packageJson = readJSON file: 'package.json'
                        def version = packageJson.version

                        # set the new version as part of IMAGE_NAME
                        env.IMAGE_NAME = "$version-$BUILD_NUMBER"
                    }
                }
            }
        }
        stage("build and test app") {
            steps {
                script {
                    dir("app") {
                        echo "building the application..."
                        sh "npm install"
                        
                        echo "testing the application..."
                        sh "npm test"
                    }
                }
            }
        }
        stage('build and push docker image') {
            steps {
                script {
                    dir("app") {
                        echo "building the docker image..."
                        withCredentials([usernamePassword(credentialsId: 'docker-hub-repo', passwordVariable: 'PASS', usernameVariable: 'USER')]){
                            sh "docker build -t chonzao/jenkins:${IMAGE_NAME} ."
                            sh 'echo $PASS | docker login -u $USER --password-stdin'
                            sh "docker push chonzao/jenkins:${IMAGE_NAME}"}
                    }
                }
            }
        }
        stage('commit version update') {
            steps {
                script {
                    echo 'commiting to git...'
                    sh 'git config --global user.email '
                    sh 'git config --global user.name "jenkins"'
                    sh 'git remote set-url origin https://$USER:$PASS@https://gitlab.com/mailo.shawn/jenkins-exercises.git'
                    sh 'git add .'
                    sh 'git commit -m "ci: version bump"'
                    sh 'git push origin HEAD:jenkins-jobs'

                }
            }
        }

    }
}
